unit Io;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus, ExtCtrls, sbaume, suchbaum, baumout, avlbaum, avlbaume;

type
  TF_Baum = class(TForm)
    MM_Baum: TMainMenu;
    MI_Element: TMenuItem;
    MI_Einfuegen: TMenuItem;
    MI_Loeschen: TMenuItem;
    MI_Datei: TMenuItem;
    MI_Beenden: TMenuItem;
    MI_Trenner_Datei1: TMenuItem;
    MI_Neu: TMenuItem;
    PB_Baum: TPaintBox;
    Integer1: TMenuItem;
    String1: TMenuItem;
    Point1: TMenuItem;
    Adress1: TMenuItem;
    N100Zufallselementeeinfgen1: TMenuItem;
    nElementelschen1: TMenuItem;
    procedure MI_EinfuegenClick(Sender: TObject);
    procedure MI_BeendenClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure MI_LoeschenClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Integer1Click(Sender: TObject);
    procedure String1Click(Sender: TObject);
    procedure Point1Click(Sender: TObject);
    procedure Adress1Click(Sender: TObject);
    procedure N100Zufallselementeeinfgen1Click(Sender: TObject);
    procedure nElementelschen1Click(Sender: TObject);
  private
    { Private-Deklarationen }
    Baum: TAVLbaum;
    BaumTyp: integer; {0: Integer; 1: String; 2: Point; 3: Adresse }
  public
    { Public-Deklarationen }
  end;

var
  F_Baum: TF_Baum;

implementation

{$R *.DFM}

procedure TF_Baum.MI_EinfuegenClick(Sender: TObject);
var Fehler: boolean;
    sbelem: Tavlbaum;
    wurzel: string; w2,w3,w4: string;

begin
  Fehler:= false;
  case Baumtyp of
    0: begin
         wurzel:= IntToStr(random(1000));
         if InputQuery('Einfgen','Geben Sie die Zahl an:',wurzel)
         then begin
                sbelem:= TIntAVLBaum.Create(StrToInt(wurzel));
                baum:= baum.avleinfuegen(sbelem,Fehler) ;
              end;
       end;
    1: begin
         wurzel:= chr(random(26)+ord('a'))+chr(random(26)+ord('a'))+chr(random(26)+ord('a'));
         if InputQuery('Einfgen','Geben Sie die Zeichenkette an:',wurzel)
         then begin
                sbelem:= TStringAVLBaum.Create(wurzel);
                baum:= baum.avleinfuegen(sbelem,Fehler) ;
              end;
       end;
    2: begin
         wurzel:= IntToStr(random(100));
         w2:= IntToStr(random(100));
         if InputQuery('Einfgen','Geben Sie die x-Koordinate an:',wurzel)
         then begin
                if InputQuery('Einfgen','Geben Sie die y-Koordinate an:',w2)
                then begin
                       sbelem:= TPointAVLBaum.Create(StrToInt(wurzel),StrToInt(w2));
                       baum:= baum.avleinfuegen(sbelem,Fehler) ;
                     end;
              end;
       end;
    3: begin
         wurzel:= chr(random(26)+ord('a'))+chr(random(26)+ord('a'))+chr(random(26)+ord('a'));
         w2:= chr(random(26)+ord('a'))+chr(random(26)+ord('a'))+chr(random(26)+ord('a'));
         w3:= IntToStr(random(9000)+1000);
         w4:= chr(random(26)+ord('a'))+chr(random(26)+ord('a'))+chr(random(26)+ord('a'));
         if InputQuery('Einfgen','Geben Sie den Namen an:',wurzel)
         then if InputQuery('Einfgen','Geben Sie den Vornamen an:',w2)
              then if InputQuery('Einfgen','Geben Sie die PLZ an:',w3)
                   then if InputQuery('Einfgen','Geben Sie den Ort an:',w4)
                        then begin
                               sbelem:= TAdressAVLBaum.Create(wurzel,w2,w3,w4);
                               baum:= baum.AVLeinfuegen(sbelem,Fehler) ;
                             end;
       end;
  end;

  if Fehler
    then MessageDlg('Element bereits vorhanden.', mtInformation,[mbOk], 0)
    else BaumAnzeigen(Baum, PB_Baum);
end;

procedure TF_Baum.MI_LoeschenClick(Sender: TObject);
var KeinFehler: boolean;
    wurzel,w2,w3,w4: string;
    sbelem: TAVLbaum;
begin
  KeinFehler:= true;
  case Baumtyp of
    0: begin
         wurzel:= '';
         if InputQuery('Lschen','Geben Sie die Wurzel an:',wurzel)
         then begin
                sbelem:= TIntAVLBaum.Create(StrToInt(wurzel));
                baum:= baum.AVLLoeschen(sbelem,KeinFehler) ;
              end;
       end;
    1: begin
         wurzel:= '';
         if InputQuery('Lschen','Geben Sie die Zeichenkette an:',wurzel)
         then begin
                sbelem:= TStringAVLBaum.Create(wurzel);
                baum:= baum.AVLLoeschen(sbelem,KeinFehler) ;
              end;
       end;
    2: begin
         wurzel:= '';
         w2:= '';
         if InputQuery('Lschen','Geben Sie die x-Koordinate an:',wurzel)
         then begin
                if InputQuery('Lschen','Geben Sie die y-Koordinate an:',w2)
                then begin
                       sbelem:= TPointAVLBaum.Create(StrToInt(wurzel),StrToInt(w2));
                       baum:= baum.AVLLoeschen(sbelem,KeinFehler) ;
                     end;
              end;
       end;
    3: begin
         wurzel:= '';
         w2:= '';
         w3:= '';
         w4:= '';
         if InputQuery('Lschen','Geben Sie den Namen an:',wurzel)
         then if InputQuery('Lschen','Geben Sie den Vornamen an:',w2)
              then if InputQuery('Lschen','Geben Sie die PLZ an:',w3)
                   then if InputQuery('Lschen','Geben Sie den Ort an:',w4)
                        then begin
                               sbelem:= TAdressAVLBaum.Create(wurzel,w2,w3,w4);
                               baum:= baum.AVLLoeschen(sbelem,KeinFehler) ;
                             end;
       end;
  end;

  if not KeinFehler
    then MessageDlg('Element ist nicht vorhanden.', mtInformation,[mbOk], 0)
    else BaumAnzeigen(Baum, PB_Baum);
end;

procedure TF_Baum.MI_BeendenClick(Sender: TObject);
begin
  Close;
end;

procedure TF_Baum.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Baum.Free;
end;

procedure TF_Baum.FormActivate(Sender: TObject);
begin
  Baumtyp:= 0;
end;

procedure TF_Baum.Integer1Click(Sender: TObject);
begin
  Baum.Free;
  Baum:= NIL;
  PB_Baum.Refresh;
  Baumtyp:= 0;
end;

procedure TF_Baum.String1Click(Sender: TObject);
begin
  Baum.Free;
  Baum:= NIL;
  PB_Baum.Refresh;
  Baumtyp:= 1;
end;

procedure TF_Baum.Point1Click(Sender: TObject);
begin
  Baum.Free;
  Baum:= NIL;
  PB_Baum.Refresh;
  Baumtyp:= 2;
end;

procedure TF_Baum.Adress1Click(Sender: TObject);
begin
  Baum.Free;
  Baum:= NIL;
  PB_Baum.Refresh;
  Baumtyp:= 3;
end;

procedure TF_Baum.N100Zufallselementeeinfgen1Click(Sender: TObject);
var Fehler: boolean;
    sbelem: Tavlbaum;
    wurzel: string; w2,w3,w4: string;
    n: integer;
    n_string: string;

begin
  n_string:= '50';
  if InputQuery('Einfgen','Wie viele Elemente?',n_string)
  then begin
         n:= 1;
         while n <= StrToInt(n_string) do
         begin
           Fehler:= false;
           case Baumtyp of
             0: begin
                  wurzel:= IntToStr(random(1000));
                  sbelem:= TIntAVLBaum.Create(StrToInt(wurzel));
                  baum:= baum.avleinfuegen(sbelem,Fehler) ;
                end;
             1: begin
                  wurzel:= chr(random(26)+ord('a'))+chr(random(26)+ord('a'))+chr(random(26)+ord('a'));
                  sbelem:= TStringAVLBaum.Create(wurzel);
                  baum:= baum.avleinfuegen(sbelem,Fehler) ;
                end;
             2: begin
                  wurzel:= IntToStr(random(100));
                  w2:= IntToStr(random(100));
                  sbelem:= TPointAVLBaum.Create(StrToInt(wurzel),StrToInt(w2));
                  baum:= baum.avleinfuegen(sbelem,Fehler) ;
                end;
             3: begin
                  wurzel:= chr(random(26)+ord('a'))+chr(random(26)+ord('a'))+chr(random(26)+ord('a'));
                  w2:= chr(random(26)+ord('a'))+chr(random(26)+ord('a'))+chr(random(26)+ord('a'));
                  w3:= IntToStr(random(9000)+1000);
                  w4:= chr(random(26)+ord('a'))+chr(random(26)+ord('a'))+chr(random(26)+ord('a'));
                  sbelem:= TAdressAVLBaum.Create(wurzel,w2,w3,w4);
                  baum:= baum.AVLeinfuegen(sbelem,Fehler) ;
                end;
           end;
           if not Fehler then inc(n);
         end;
       end;
  BaumAnzeigen(Baum, PB_Baum);
end;

procedure TF_Baum.nElementelschen1Click(Sender: TObject);
var Fehler: boolean;
    sbelem: Tavlbaum;
    wurzel: string; w2,w3,w4: string;
    n: integer;
    n_string: string;
begin
  n_string:= '50';
  if InputQuery('Lschen','Wie viele Elemente?',n_string)
  then begin
         n:= 1;
         while (n <= StrToInt(n_string)) and (not baum.leer) do
         begin
           Fehler:= false;
           case Baumtyp of
             0: begin
                  wurzel:= IntToStr(random(1000));
                  sbelem:= TIntAVLBaum.Create(StrToInt(wurzel));
                  baum:= baum.avlloeschen(sbelem,Fehler) ;
                end;
             1: begin
                  wurzel:= chr(random(26)+ord('a'))+chr(random(26)+ord('a'))+chr(random(26)+ord('a'));
                  sbelem:= TStringAVLBaum.Create(wurzel);
                  baum:= baum.avlloeschen(sbelem,Fehler) ;
                end;
             2: begin
                  wurzel:= IntToStr(random(100));
                  w2:= IntToStr(random(100));
                  sbelem:= TPointAVLBaum.Create(StrToInt(wurzel),StrToInt(w2));
                  baum:= baum.avlloeschen(sbelem,Fehler) ;
                end;
             3: begin
                  wurzel:= chr(random(26)+ord('a'))+chr(random(26)+ord('a'))+chr(random(26)+ord('a'));
                  w2:= chr(random(26)+ord('a'))+chr(random(26)+ord('a'))+chr(random(26)+ord('a'));
                  w3:= IntToStr(random(9000)+1000);
                  w4:= chr(random(26)+ord('a'))+chr(random(26)+ord('a'))+chr(random(26)+ord('a'));
                  sbelem:= TAdressAVLBaum.Create(wurzel,w2,w3,w4);
                  baum:= baum.AVLloeschen(sbelem,Fehler) ;
                end;
           end;
           if Fehler then inc(n);
         end;
       end;
  BaumAnzeigen(Baum, PB_Baum);
end;

end.
